;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

	cFactorInit			= 0fd379ab1h
	cFactorLoop			= 0a7753394h
	cSummand			= 03bc62bb2h

	CalcCRC_Section		PROTO
	CalcCRC_Block		PROTO

;-----------------------------------------------------------------------------

prGetProofCRC		PROC

	pushm	eax, edx, esi
	test	[dwFlags], cFlag_Raw_KeysFound
	je		@@NoKey

	lea		esi, dwRaw_Key+4
	lodsd
	mov		edx, eax
	lodsd
	cmp		eax, edx
	jne		@@NoKey
	lodsd
	cmp		eax, edx
	jne		@@NoKey
	xor		edx, [esi][-16]
	mov		[dwCrcRead], edx
	or		[dwFlags], cFlag_CRC_ReadFound
	mov		[bChangedCrc], -1
@@NoKey:
	popm	esi, edx, eax
	ret

prGetProofCRC		ENDP


;-----------------------------------------------------------------------------

prCalcCodeCRC		PROC

	pushad
	mov		[dwCrcCalc], 0
	mov		eax, [dwFlags]
	lea		ebp, stFileMem
	test	eax, cFlag_IcdLoaded
	jne		@@Calc
	lea		ebp, stExeFileMem
	and		eax, cFlag_VersionFound+cFlag_ExeLoaded
	cmp		eax, cFlag_VersionFound+cFlag_ExeLoaded
	jne		@@NoICD
	cmp		[dwVersion], 20000000h
	jb		@@NoICD

@@Calc:
	mov		[pStSafeMem], ebp
	lea		esi, tSectionParam
	mov		ecx, [dwSectionNum]

@@MainLp:
	mov		eax, [esi][stcSectionParam.dwSize]
	test	eax, eax
	je		@@NoCodeSec

	mov		eax, [esi][stcSectionParam.dwFlags]
	test	eax, 0ffffh
	jne		@@NoCodeSec

	not		eax
	test	eax, (cFlag_SecInCode or cFlag_SecCode or cFlag_SecExeable)
	jne		@@NoCodeSec
	or		[dwFlags], cFlag_CRC_CalcFound

	pushm	ecx, esi
	mov		ecx, [esi][stcSectionParam.dwSize]
	mov		edi, [esi][stcSectionParam.dwRVA]
	mov		esi, [esi][stcSectionParam.dwFOA]
	invoke	CalcCRC_Section
	popm	esi, ecx

@@NoCodeSec:
	add		esi, sizeof stcSectionParam
	loop	@@MainLp
	mov		[bChangedCrc], -1

@@NoICD:
	popad
	ret

prCalcCodeCRC		ENDP


;-----------------------------------------------------------------------------

CalcCRC_Section	PROC		; esi = FOA, edi = RVA, ecx = Size

	mov		[dwLastReloc], 0

@@Lop:
	pushm	ecx, esi, edi
	cmp		ecx, 1000h
	jbe		@@SizeOk
	mov		ecx, 1000h

@@SizeOk:
	mov		eax, [dwRelocFOA]
	test	eax, eax
	je		@@NoReloc

	mov		[ebp][stcSafeMem.dwBase], eax

@@FindReloc:
	mov		[ebp][stcSafeMem.dwOffset], 0
	invoke	ReadSafeMem
	test	eax, eax					; 0 = End
	je		@@NoReloc

	mov		edx, eax					; RelocBase
	mov		[ebp][stcSafeMem.dwOffset], 4
	invoke	ReadSafeMem
	cmp		edx, edi					; equal Base ?
	je		@@Found
	add		[ebp][stcSafeMem.dwBase], eax		; Blocksize
	jmp		@@FindReloc

@@Found:
	sub		eax, 8
	shr		eax, 1
	je		@@NoReloc

	pushm	ecx, edi
	mov		ecx, eax
	mov		[ebp][stcSafeMem.dwOffset], 8
	lea		edi, tCRC_RelocBuffer

@@CreateRelocBuffer:
	invoke	ReadSafeMem
	mov		edx, eax
	and		edx, 0f000h
	cmp		edx, 03000h
	jne		@@Sorted
	and		eax, 0fffh
	mov		edx, edi
	stosw

@@Sort:
	sub		edx, 2
	mov		eax, [edx]
	ror		eax, 16
	cmp		ax, [edx]
	jg		@@Sorted
	mov		[edx], eax
	jmp		@@Sort

@@Sorted:
	add		[ebp][stcSafeMem.dwOffset], 2
	loop	@@CreateRelocBuffer
	lea		eax, tCRC_RelocBuffer
	mov		[pRelocBuffer], eax
	mov		edx, edi
	sub		edx, eax
	shr		edx, 1
	mov		[dwBlockRelocNum], edx
	popm	edi, ecx

	mov		eax, [dwLastReloc]
	sub		eax, 0ffch
	jle		@@NoTakeOver
	mov		[dwLastReloc], 0

@@Lp:
	add		esi, eax
	add		edi, eax
	sub		ecx, eax
	jle		@@Done

@@NoTakeOver:
	mov		eax, [dwBlockRelocNum]
	dec		eax
	js		@@NoReloc
	mov		[dwBlockRelocNum], eax
	mov		eax, [pRelocBuffer]
	movzx	edx, word ptr [eax]
	add		[pRelocBuffer], 2
	mov		[dwLastReloc], edx
	push	ecx
	mov		ecx, edx
	sub		ecx, edi					; RVA
	and		ecx, 0fffh
	push	ecx
	je		@@NoBlock
	invoke	CalcCRC_Block

@@NoBlock:
	pop		eax							; SubBlockSize
	pop		ecx							; OldBlockSize
	sub		ecx, eax					; RestBlockSize
	mov		eax, 4
	jmp		@@Lp

@@NoReloc:
	invoke	CalcCRC_Block

@@Done:
	popm	edi, esi, ecx
	mov		eax, 1000h
	add		esi, eax
	add		edi, eax
	sub		ecx, eax
	ja		@@Lop
	ret

CalcCRC_Section	ENDP


;-----------------------------------------------------------------------------

CalcCRC_Block	PROC		; esi = FOA, edi = RVA, ecx = Size

	pushm	eax, edx
	add		edi, ecx
	mov		[ebp][stcSafeMem.dwOffset], 0
	mov		edx, cFactorInit

@@Lp:
	mov		[ebp][stcSafeMem.dwBase], esi
	invoke	ReadSafeMem
	movzx	eax, al
	imul	eax, edx
	add		[dwCrcCalc], eax
	imul	edx, cFactorLoop
	lea		edx, [edx][ecx][cSummand-1]					; new (next) Factor

	inc		esi

	loop	@@Lp
	popm	edx, eax
	ret

CalcCRC_Block	ENDP


;-----------------------------------------------------------------------------
