;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


	CalcR2_InitMarkTab				PROTO
	CalcR2_SearchCryptedDlls		PROTO
	CalcR2_CalcTEAKeyMask			PROTO
	CalcR2_CalcAsciiKey				PROTO
	CalcR2_UnmarkNonCryptedAsciis	PROTO
	CalcR2_ScanForKeys				PROTO
	CalcR2_ProofKeys				PROTO
	CalcR2_UnmarkPointedAsciis		PROTO
	CalcR2_SearchLeftCryptedAsciis	PROTO
	CalcR2_SearchDllKeys			PROTO

;-----------------------------------------------------------------------------


prCalcR2Key		PROC

	pushad
	lea		ebp, stFileMem					; const for sub-r
	test	[dwFlags], cFlag_VersionFound
	je		@@NoFile
	test	[dwFlags], cFlag_IcdLoaded
	jne		@@Calc
	lea		ebp, stExeFileMem				; const for sub-r
	test	[dwFlags], cFlag_ExeLoaded
	je		@@NoFile
	cmp		[dwVersion], 20000000h
	jb		@@NoFile

@@Calc:
	cmp		[dwVersion], 1001e000h
	jb		@@NoFile
	cmp		[dwImportFOA], 0
	je		@@NoFile

	m2m		[ebp][stcSafeMem.dwBase], [dwImportSectionFOA]
	mov		[pStSafeMem], ebp

	invoke	CalcR2_InitMarkTab				; allocates MarkTab
	test	[dwFlags], cFlag_ErrAllocMem
	jne		@@NoFile

	invoke	CalcR2_SearchCryptedDlls
	cmp		[dwDllKeyNum], 0				; No crypted Dlls?
	je		@@NoFile

	invoke	CalcR2_CalcTEAKeyMask
	invoke	CalcR2_CalcAsciiKey
	invoke	CalcR2_UnmarkNonCryptedAsciis
	invoke	CalcR2_ScanForKeys

	test	[dwFlags], cFlag_ErrAllocMem
	jne		@@NoFile
	cmp		[dwNumFoundKeys], 0
	je		@@NoFile

	invoke	CalcR2_ProofKeys
	test	[dwFlags], cFlag_TEA_KeyFound
	je		@@NoFile

	mov		[bChangedTea], -1

	invoke	CalcR2_UnmarkPointedAsciis
	invoke	CalcR2_SearchLeftCryptedAsciis
	mov		eax, [dwNumLeftAsciis]
	cmp		eax, [dwDllKeyNum]
	jl		@@NoFile

	invoke	CalcR2_SearchDllKeys

	mov		[bChangedDll], -1
@@NoFile:
	popad
	ret

prCalcR2Key		ENDP

;-----------------------------------------------------------------------------


	include	Strings.inc
	include	InitMarkTab.inc
	include	SearchCryptedDlls.inc
	include	CalcTEAKeyMask.inc
	include	CalcAsciiKey.inc
	include	UnmarkNonCryptedAsciis.inc
	include	ScanForKeys.inc
	include	ProofKeys.inc
	include	UnmarkPointedAsciis.inc
	include	SearchLeftCryptedAsciis.inc
	include	SearchDllKeys.inc

;-----------------------------------------------------------------------------
