;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


CalcR2_ProofKeys	PROC

	mov		esi, [pKeyTabMem]
	mov		edi, [esi]							; TEA Key
	mov		ecx, [dwNumFoundKeys]
	cmp		ecx, 1
	jl		@@Error
	je		@@Done

@@MainLp:
	mov		edi, [esi]							; TEA Key
	add		esi, 4
	push	ecx

	lea		ebx, stDlls
	mov		ecx, [dwDllKeyNum]

@@Lop:
	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pName]
	pushad
	invoke	CalcR2_TransString
	invoke	LoadLibrary, offset szTextBuffer
	mov		[hDllHandle], eax
	test	eax, eax
	popad
	je		@@Error

	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pOrgThunk]

@@Lp:
	add		[ebp][stcSafeMem.dwOffset], 4
	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem
	test	eax, eax
	je		@@NextDll
	xor		eax, edi						; decrypt
	sub		eax, [dwImportSectionRVA]

	push	[ebp][stcSafeMem.dwOffset]
	mov		[ebp][stcSafeMem.dwOffset], eax
	invoke	CalcR2_DecryptString
	pop		[ebp][stcSafeMem.dwOffset]

	pushad
	invoke	GetProcAddress, [hDllHandle], offset szTextBuffer
	test	eax, eax
	popad
	je		@@NextKey
	jmp		@@Lp

@@NextKey:
	pushm	esi, edi
	invoke	FreeLibrary, [hDllHandle]
	popm	edi, esi, ecx
	dec		ecx
	jne		@@MainLp					;	loop	@@MainLp (too long distance)
	ret

@@NextDll:
	pushad
	invoke	FreeLibrary, [hDllHandle]
	popad
	add		ebx, stDllSize
	dec		ecx
	jne		@@Lop						;	loop	@@Lop (too long distance)
	pop		ecx							; All Ok

@@Done:
	mov		[dwTEA_Key], edi
	or		[dwFlags], cFlag_TEA_KeyFound

@@Error:
	ret

CalcR2_ProofKeys	ENDP


;-----------------------------------------------------------------------------
