;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

	CalcR2_UnmarkLen		PROTO
	CalcR2_UnmarkString		PROTO
	CalcR2_UnmarkThunk		PROTO


CalcR2_SearchCryptedDlls	PROC

	pushad
	mov		edx, [dwImportRVA]
	sub		edx, [dwImportSectionRVA]
	mov		[ebp][stcSafeMem.dwOffset], edx
	lea		ebx, stDlls

@@MainLp:
	mov		ecx, 5*2
	invoke	CalcR2_UnmarkLen
	mov		[pStSafeMem], ebp

	invoke	ReadSafeMem
	add		[ebp][stcSafeMem.dwOffset], 4
	mov		edx, eax
	sub		eax, [dwImportSectionRVA]
	mov		[ebx][stcDllKey.pOrgThunk], eax

	invoke	ReadSafeMem
	add		[ebp][stcSafeMem.dwOffset], 4
	or		edx, eax

	invoke	ReadSafeMem
	add		[ebp][stcSafeMem.dwOffset], 4
	or		edx, eax

	invoke	ReadSafeMem
	add		[ebp][stcSafeMem.dwOffset], 4
	or		edx, eax
	sub		eax, [dwImportSectionRVA]
	mov		[ebx][stcDllKey.pName], eax

	invoke	ReadSafeMem
	add		[ebp][stcSafeMem.dwOffset], 4
	or		edx, eax
	sub		eax, [dwImportSectionRVA]
	mov		[ebx][stcDllKey.pThunk], eax

	test	edx, edx
	je		@@Done


	push	[ebp][stcSafeMem.dwOffset]		; backup

	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pName]
	invoke	CalcR2_UnmarkString

	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pOrgThunk]
	invoke	CalcR2_UnmarkThunk

	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pThunk]
	invoke	CalcR2_UnmarkThunk

	pop		[ebp][stcSafeMem.dwOffset]		; restore
	test	eax, eax						; CalcR2_UnmarkThunk returns 0 if crypted
	jne		@@MainLp

@@Count:
	cmp		[dwDllKeyNum], 6				; 6 cryted Dlls is max
	je		@@MainLp
	inc		[dwDllKeyNum]
	add		ebx, stDllSize
	jmp		@@MainLp

@@Done:
	popad
	ret

CalcR2_SearchCryptedDlls	ENDP


;-----------------------------------------------------------------------------

CalcR2_UnmarkLen	PROC

	mov		[pStSafeMem], offset stMarkTabMem
	mov		eax, [ebp][stcSafeMem.dwOffset]
	shr		eax, 1
	mov		[stMarkTabMem.dwOffset], eax
	sub		eax, eax

@@Lp:
	invoke	WriteSafeMemB
	inc		[stMarkTabMem.dwOffset]
	loop	@@Lp
	ret


CalcR2_UnmarkLen	ENDP


;-----------------------------------------------------------------------------

CalcR2_UnmarkThunk	PROC

	push	[ebp][stcSafeMem.dwOffset]					; backup to calc size later

@@Lp:
	mov		[pStSafeMem], offset stMarkTabMem
	mov		eax, [ebp][stcSafeMem.dwOffset]
	shr		eax, 1
	mov		[stMarkTabMem.dwOffset], eax
	sub		eax, eax
	invoke	WriteSafeMemW

	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem
	test	eax, eax
	je		@@Done
	js		@@Next

	push	[ebp][stcSafeMem.dwOffset]
	sub		eax, [dwImportSectionRVA]
	mov		edx, eax
	add		eax, 2
	mov		[ebp][stcSafeMem.dwOffset], eax
	shr		edx, 1
	mov		[stMarkTabMem.dwOffset], edx
	mov		[pStSafeMem], offset stMarkTabMem
	sub		eax, eax
	invoke	WriteSafeMemB
	invoke	CalcR2_UnmarkString
	pop		[ebp][stcSafeMem.dwOffset]
@@Next:
	add		[ebp][stcSafeMem.dwOffset], 4
	jmp		@@Lp

@@Done:
	mov		eax, [ebp][stcSafeMem.dwOffset]
	pop		[ebp][stcSafeMem.dwOffset]
	sub		eax, [ebp][stcSafeMem.dwOffset]
	ret

CalcR2_UnmarkThunk	ENDP


;-----------------------------------------------------------------------------

CalcR2_UnmarkString		PROC

	jmp		@@Lp2
@@Lp:
	inc		[ebp][stcSafeMem.dwOffset]
@@Lp2:
	mov		[pStSafeMem], offset stMarkTabMem
	mov		eax, [ebp][stcSafeMem.dwOffset]
	shr		eax, 1
	mov		[stMarkTabMem.dwOffset], eax
	sub		eax, eax
	invoke	WriteSafeMemB

	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem
	test	al, al
	jne		@@Lp
	ret

CalcR2_UnmarkString		ENDP


;-----------------------------------------------------------------------------
