;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

CalcR2_UnmarkNonCryptedAsciis	PROC

	pushad
	mov		esi, [stMarkTabMem.pMem]
	mov		ecx, [stMarkTabMem.dwSize]
	sub		ecx, 2
	jbe		@@Done

@@MainLp:
	cmp		byte ptr [esi][ecx], 0			; already marked?
	je		@@Next

	mov		[ebp][stcSafeMem.dwOffset], ecx
	add		[ebp][stcSafeMem.dwOffset], ecx	; 2*ecx
	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem

	sub		edx, edx
	mov		dl, al							; Num of crypted asciis
	mov		dh, al							; backup
	test	dl, 0c0h						; a procname longer than 63 bytes seems to be wrong
	jne		@@MarkThis
	cmp		dl, 3							; a procname shorter then 3 seems to be wrong too
	jb		@@MarkThis

	shr		eax, 8							; next 2 bytes in al, ah
	xor		al, 03dh
	xor		ah, [bAsciiKey]
	cmp		al, ah
	jne		@@MarkThis						; 2 ways of decrypting the first byte
	inc		[ebp][stcSafeMem.dwOffset]
	jmp		@@FirstTest

@@Lp:
	inc		[ebp][stcSafeMem.dwOffset]
	invoke	ReadSafeMem
	xor		al, ah

@@FirstTest:
	cmp		dl, 1						; last Stringbyte must be sero
	jne		@@NotLast
	test	al, al
	jne		@@MarkThis
	je		@@OkSoFar

@@NotLast:
	test	al, al
	je		@@MarkThis					; only last byte should be sero
	test	al, 80h
	jne		@@MarkThis					; all > 7f wrong
	cmp		al, 20h
	jl		@@MarkThis					; all < 20 wrong

	dec		dl
	jne		@@Lp

@@OkSoFar:
	test	dh, 1
	je		@@Next						; num even -> Next
	invoke	ReadSafeMem
	test	eax, 0ff0000h				; fillbyte has to (normaly should) be sero
	je		@@Next

@@MarkThis:
	not		byte ptr [esi][ecx]

@@Next:
	dec		ecx
	jne		@@MainLp

@@Done:
	popad
	ret

CalcR2_UnmarkNonCryptedAsciis	ENDP


;-----------------------------------------------------------------------------
