;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

prFindVersionStruc	PROTO	:DWORD

;-----------------------------------------------------------------------------


prGetVersion		PROC

	pushad
	test	[dwFlags], cFlag_IcdLoaded
	je		@@NoIcd

	invoke	prFindVersionStruc, [stFileMem.pMem]
	je		@@VersionFound
	test	[dwFlags], cFlag_ExeLoaded
	jne		@@NoV2

@@NoIcd:
	test	[dwFlags], cFlag_ExeLoaded
	je		@@NoVersion
	invoke	prFindVersionStruc, [stExeFileMem.pMem]
	je		@@VersionFound

@@NoV2:
	mov		ecx, [stExeFileMem.dwSize]
	sub		ecx, cVersionStrucLen
	jle		@@NoVersion
@@Lop:
	mov		esi, [stExeFileMem.pMem]
	mov		eax, dword ptr [szProofString]
@@Lp:
	cmp		eax, [esi][ecx]
	je		@@Found1
	loop	@@Lp
	jmp		@@NoVersion
@@Next:
	loop	@@Lop
	jmp		@@NoVersion

@@Found1:
	push	ecx
	lea		edi, [esi][ecx]
	invoke	lstrcmp, offset szProofString, edi
	test	eax, eax
	pop		ecx
	jne		@@Next

	mov		eax, [edi][cVersionDwords][-12]
	cmp		eax, [edi][cVersionDwords][0]
	jne		@@Next
	test	eax, 0fffffffch
	jne		@@Next
	mov		eax, [edi][cVersionDwords][-8]
	cmp		eax, [edi][cVersionDwords][4]
	jne		@@Next
	test	eax, 0ffffff00h
	jne		@@Next
	mov		eax, [edi][cVersionDwords][-4]
	cmp		eax, [edi][cVersionDwords][8]
	jne		@@Next
	test	eax, 0fffff000h
	jne		@@Next
	mov		esi, edi

@@VersionFound:
	or		[dwFlags], cFlag_VersionFound
	add		esi, cVersionDwords
	lodsd
	mov		[dwVersion1], eax
	mov		edx, eax
	shl		edx, 28-12
	lodsd
	mov		[dwVersion2], eax
	mov		dx, ax
	shl		edx, 12
	lodsd
	mov		[dwVersion3], eax
	and		eax, 0fffh
	or		edx, eax
	and		edx, 300fffffh
	mov		[dwVersion], edx							; One Version dword
	mov		[bChangedVersion], -1

	sub		ebx, ebx									; last release found
	lea		esi, tVersionList
@@ReleaseLp:
	lodsd
	test	eax, eax
	je		@@Outside
	cmp		eax, edx
	ja		@@Outside
	lodsd												; Release
	mov		ebx, eax
	jne		@@ReleaseLp

	or		[dwFlags], cFlag_VersionKnown
@@Outside:
	add		bh, 60h
	movzx	eax, bl
	mov		[dwRelease3], eax
	movzx	eax, bh
	mov		[dwRelease2], eax
	bswap	ebx
	movzx	eax, bh
	mov		[dwRelease1], eax
	mov		[bChangedRelease], -1

@@NoVersion:
	popad
	ret


prGetVersion		ENDP

;-----------------------------------------------------------------------------

prFindVersionStruc	PROC	arg_pMem	:DWORD				; -> esi=ptr

	mov		eax, [dwPE_FirstSection]
	sub		eax, cVersionStrucLen
	jb		@@Ciao
	add		eax, [arg_pMem]
	push	eax
	invoke	lstrcmp, offset szProofString, eax
	test	eax, eax
	pop		esi
	jne		@@Ciao								; Error
	sub		eax, eax

@@Ciao:
	test	eax, eax
	ret

prFindVersionStruc	ENDP

;-----------------------------------------------------------------------------
