;*****************************************************************************
;*
;*	Get Safedisc Version (GetSecParam)
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

cPE_DirEntrys			= 78h
cPE_SectionHeader		= 0f8h						; PE-Offset to Section Header

cPE_SectionSSize		= 08h
cPE_SectionRVA			= 0ch
cPE_SectionFSize		= 10h
cPE_SectionFOA			= 14h
cPE_SectionFlags		= 24h
cPE_SectionHeaderSize	= 28h

;-----------------------------------------------------------------------------

prGetSecParam		PROC

	pushad
	mov		esi, [pStSafeMem]
	mov		eax, [dwPE_Offset]
	add		eax, cPE_SectionHeader
	mov		[esi][stcSafeMem.dwBase], eax

	lea		edi, tSectionParam
	mov		ecx, [dwSectionNum]

@@Lop:
	lea		edx, ReadSafeMem
	mov		[esi][stcSafeMem.dwOffset], cPE_SectionRVA
	call	edx
	stosd
	mov		[esi][stcSafeMem.dwOffset], cPE_SectionFOA
	call	edx
	stosd
	mov		[esi][stcSafeMem.dwOffset], cPE_SectionSSize
	call	edx
	test	eax, eax
	jne		@@SizeOk
	mov		[esi][stcSafeMem.dwOffset], cPE_SectionFSize
	call	edx
@@SizeOk:
	stosd
	mov		[esi][stcSafeMem.dwOffset], cPE_SectionFlags
	call	edx

	mov		ebx, eax
	and		eax, 0e0000000h

	shl		ebx, 3
	and		ebx, 01fffffffh
	or		eax, ebx
	and		eax, 0f0000000h

	shl		ebx, 16-3
	and		ebx, 00fffffffh
	or		eax, ebx
	and		eax, 0f8000000h

	shl		ebx, 19-16
	and		ebx, 007ffffffh
	or		eax, ebx
	and		eax, 0ff000000h

	mov		ebx, [dwCodeStart]
	cmp		ebx, [edi][-12]		; RVA
	ja		@@OutsideCode
	add		ebx, [dwCodeSize]
	cmp		ebx, [edi][-12]		; RVA
	jle		@@OutsideCode
	or		eax, cFlag_SecInCode

@@OutsideCode:
	mov		ebx, [dwDataStart]
	cmp		ebx, [edi][-12]		; RVA
	ja		@@OutsideData
	add		ebx, [dwDataSize]
	cmp		ebx, [edi][-12]		; RVA
	jle		@@OutsideData
	or		eax, cFlag_SecInData

@@OutsideData:
	pushm	ecx, [esi][stcSafeMem.dwBase], eax
	mov		ecx, 16
	mov		edx, 1
	mov		eax, [dwPE_Offset]
	mov		[esi][stcSafeMem.dwBase], eax
	mov		[esi][stcSafeMem.dwOffset], cPE_DirEntrys

@@Lp:
	invoke	ReadSafeMem
	mov		ebx, [edi][-12]		; RVA
	cmp		eax, ebx
	jl		@@Outside
	add		ebx, [edi][-4]		; + Size
	cmp		eax, ebx
	jae		@@Outside
	pop		eax
	or		eax, edx
	push	eax
@@Outside:
	add		[esi][stcSafeMem.dwOffset], 8
	shl		edx, 1
	loop	@@Lp
	popm	eax, [esi][stcSafeMem.dwBase], ecx
	stosd

	add		[esi][stcSafeMem.dwBase], cPE_SectionHeaderSize
	dec		ecx
	jne		@@Lop
	popad
	ret


prGetSecParam		ENDP


;-----------------------------------------------------------------------------
