;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

prOpenFile		PROTO :DWORD,:DWORD,:DWORD,:DWORD
prPE_Analyse	PROTO
prGetSecParam	PROTO
prFindImports	PROTO
prFindRelocs	PROTO

;-----------------------------------------------------------------------------


prOpenFiles		PROC

	pushm	ecx, esi, edi

	invoke	prOpenFile, offset szMask_EXE, offset hEXE_File, offset stExeFileMem.dwSize, offset stExeFileMem.pMem
	jne		@@NoV2		; = No Exe

	invoke	prTransString, offset szOFN_FileName, offset szExeName, 200h
	mov		[bChangedExeName], -1
	or		[dwFlags], cFlag_ExeLoaded

	m2m		[pStSafeMem], offset stExeFileMem
	invoke	prPE_Analyse
	jne		@@Err_StructureExe

	lea		edi, stExeFileMem
	lea		esi, ReadSafeMem
	m2m		[stExeFileMem.dwBase], [dwPE_Offset]
	mov		[stExeFileMem.dwOffset], 0f8h+2*28h
	mov		ecx, [dwSectionNum]
	sub		ecx, 2
	jbe		@@NoV2

@@V2Lp:
	call	esi
	cmp		eax, "txts"
	jne		@@V2Next
	add		[edi][stcSafeMem.dwOffset], 4
	call	esi
	cmp		eax, 00313733h
	jne		@@V2Next2

	add		[edi][stcSafeMem.dwOffset], 8
	call	esi
	mov		edx, eax							; RVA
	add		[edi][stcSafeMem.dwOffset], 8
	call	esi
	mov		[edi][stcSafeMem.dwBase], eax		; FileOffset
	mov		[edi][stcSafeMem.dwOffset], 9		; org. Import RVA
	call	esi
	mov		[dwImportRVA], eax
	mov		[edi][stcSafeMem.dwOffset], 13		; org. Import Size
	call	esi
	m2m		[stExeFileMem.dwBase], [dwPE_Offset]
	mov		[stExeFileMem.dwOffset], cPE_ImportRVA+4
	call	WriteSafeMem
	mov		eax, [dwImportRVA]
	mov		[stExeFileMem.dwOffset], cPE_ImportRVA
	call	WriteSafeMem

	invoke	prGetSecParam
	invoke	prFindImports
	or		[dwFlags], cFlag_ExeLoaded
	jmp		@@NoICD									; v2 -> No ICD anymore

@@V2Next:
	add		[edi][stcSafeMem.dwOffset], 4
@@V2Next2:
	add		[edi][stcSafeMem.dwOffset], 24h
	dec		ecx
	jne		@@V2Lp

;-----------------------------------------------------------------------------

@@NoV2:
	invoke	prOpenFile, offset szMask_ICD, offset hICD_File, offset stFileMem.dwSize, offset stFileMem.pMem
	jne		@@NoICD

	invoke	prTransString, offset szOFN_FileName, offset szIcdName, 200h
	mov		[bChangedIcdName], -1

	m2m		[pStSafeMem], offset stFileMem
	invoke	prPE_Analyse
	jne		@@Err_StructureICD
	invoke	prGetSecParam
	invoke	prFindImports
	invoke	prFindRelocs
	or		[dwFlags], cFlag_IcdLoaded

@@NoICD:
	popm	edi, esi, ecx
	ret

@@Err_StructureExe:
	push	offset @@NoV2
	jmp		@@Err_Structure

@@Err_StructureICD:
	push	offset @@NoICD

@@Err_Structure:
	or		[dwFlags], cFlag_ErrStructure
	invoke	MessageBox, [hWnd], offset szErrStructure, offset szWinTitle, MB_ICONERROR
	db		0c3h

prOpenFiles		ENDP

;-----------------------------------------------------------------------------


	include	OpenFile.inc
	include	PE_Analyse.inc
	include	GetSecParam.inc
	include	FindImports.inc
	include	FindRelocs.inc

;-----------------------------------------------------------------------------
