;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

prPE_Analyse	PROC

	pushad
	sub		eax, eax
	mov		edi, [pStSafeMem]
	lea		esi, ReadSafeMem
	mov		[edi][stcSafeMem.dwBase], eax
	mov		[edi][stcSafeMem.dwOffset], eax

	call	esi
	cmp		ax, cMZ_Sign
	jne		@@Err_Structure

	mov		[edi][stcSafeMem.dwOffset], cMZ_ExeExt
	call	esi											; ax = Offset PE-Structure
	and		eax, 0ffffh
	mov		[dwPE_Offset], eax
	mov		[edi][stcSafeMem.dwBase], eax

	mov		[edi][stcSafeMem.dwOffset], 0
	call	esi
	cmp		eax, cPE_Sign
	jne		@@Err_Structure

	mov		[edi][stcSafeMem.dwOffset], cPE_OptH_Size
	call	esi
	cmp		ax, cPE_OptH_SizeProof
	jne		@@Err_Structure

	mov		[edi][stcSafeMem.dwOffset], cPE_OptH_Sign
	call	esi
	cmp		ax, cPE_OptH_SignProof
	jne		@@Err_Structure

	mov		[edi][stcSafeMem.dwOffset], cPE_FirstSection
	call	esi
	and		eax, 3fffffffh
	cmp		eax, [edi][stcSafeMem.dwSize]
	jae		@@Err_Structure
	mov		[dwPE_FirstSection], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_CodeStart
	call	esi
	mov		[dwCodeStart], eax
	mov		[edi][stcSafeMem.dwOffset], cPE_CodeSize
	call	esi
	mov		[dwCodeSize], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_DataStart
	call	esi
	mov		[dwDataStart], eax
	mov		[edi][stcSafeMem.dwOffset], cPE_DataSize
	call	esi
	mov		[dwDataSize], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_Entry
	call	esi
	mov		[dwEntrypoint], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_ImportRVA
	call	esi
	mov		[dwImportRVA], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_RelocRVA
	call	esi
	mov		[dwRelocRVA], eax

	mov		[edi][stcSafeMem.dwOffset], cPE_SectionHeaderNum
	call	esi
	and		eax, 1fh
	mov		[dwSectionNum], eax

	sub		al, al
@@Ciao:
	test	al, al
	popad
	ret

@@Err_Structure:
	mov		al, 1
	jmp		@@Ciao

prPE_Analyse	ENDP

;-----------------------------------------------------------------------------
