;*****************************************************************************
;*
;*	Get Safedisc Version (SafeMemOps)
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

cMaxSafeMemOffsetMask		= 7ffffffh


ReadSafeMem		PROC

	sub		eax, eax							; returns the read dw in eax
	pushm	esi, edi
	mov		edi, [pStSafeMem]					; Memory Structure Ptr
	mov		esi, [edi][stcSafeMem.dwBase]		; Base Offset
	add		esi, [edi][stcSafeMem.dwOffset]		; Additional Offset

	and		esi, cMaxSafeMemOffsetMask
	cmp		esi, [edi][stcSafeMem.dwSize]
	jae		@@Outside

	add		esi, [edi][stcSafeMem.pMem]			; Memory Base Ptr
	lodsd

@@Outside:
	popm	edi, esi
	ret

ReadSafeMem		ENDP


;-----------------------------------------------------------------------------

WriteSafeMem		PROC

	pushm	esi, edi
	mov		esi, [pStSafeMem]
	mov		edi, [esi][stcSafeMem.dwBase]
	add		edi, [esi][stcSafeMem.dwOffset]

	and		edi, cMaxSafeMemOffsetMask
	cmp		edi, [esi][stcSafeMem.dwSize]
	jae		@@Outside

	add		edi, [esi][stcSafeMem.pMem]
	stosd											; store dw in eax

@@Outside:
	popm	edi, esi
	ret

WriteSafeMem		ENDP


;-----------------------------------------------------------------------------

WriteSafeMemW		PROC

	pushm	esi, edi
	mov		esi, [pStSafeMem]
	mov		edi, [esi][stcSafeMem.dwBase]
	add		edi, [esi][stcSafeMem.dwOffset]

	and		edi, cMaxSafeMemOffsetMask
	cmp		edi, [esi][stcSafeMem.dwSize]
	jae		@@Outside

	add		edi, [esi][stcSafeMem.pMem]
	stosw

@@Outside:
	popm	edi, esi
	ret

WriteSafeMemW		ENDP


;-----------------------------------------------------------------------------

WriteSafeMemB		PROC

	pushm	esi, edi
	mov		esi, [pStSafeMem]
	mov		edi, [esi][stcSafeMem.dwBase]
	add		edi, [esi][stcSafeMem.dwOffset]

	and		edi, cMaxSafeMemOffsetMask
	cmp		edi, [esi][stcSafeMem.dwSize]
	jae		@@Outside

	add		edi, [esi][stcSafeMem.pMem]
	stosb

@@Outside:
	popm	edi, esi
	ret

WriteSafeMemB		ENDP


;-----------------------------------------------------------------------------
